﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Pdf;
using System.IO;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;

namespace WebApplication1
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            //PdfDocument doc = new PdfDocument();
            //PdfPage page = doc.Pages.Add();
            //string dataPath = Server.MapPath("~/bin/App_Data/PDF.pfx");
            //PdfCertificate certificate = new PdfCertificate(dataPath, "syncfusion", KeyStorageFlags.MachineKeySet);

            //// Signature
            //PdfSignature signature = new PdfSignature(doc, page, certificate, "Signature");
            //signature.ContactInfo = "johndoe@owned.us";

            //signature.LocationInfo = "Honolulu, Hawaii";

            //signature.Reason = "I am author of this document.";
            //signature.Certificate = certificate;

            //signature.Bounds = new System.Drawing.RectangleF(0, 0, 300, 300);
            //MemoryStream stream = new MemoryStream();
            //doc.Save(stream);

            string dataPath = Server.MapPath("~/bin/App_Data/Barcode.pdf");


            PdfLoadedDocument loadedDocument = new PdfLoadedDocument(dataPath);

            var page = loadedDocument.Pages[0] as PdfLoadedPage;

            dataPath = Server.MapPath("~/bin/App_Data/PDF.pfx");
            Stream s= new FileStream(dataPath, FileMode.Open);
          
            byte[] b;

            using (BinaryReader br = new BinaryReader(s))
            {
                b = br.ReadBytes((int)s.Length);
            }
            var certificateTemporaryFilePath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, $"{Guid.NewGuid()}.pfx");
            File.WriteAllBytes(certificateTemporaryFilePath,b);
            var certificate = new PdfCertificate(certificateTemporaryFilePath, "syncfusion",KeyStorageFlags.MachineKeySet);

            // Signature
            var signature = new PdfSignature(loadedDocument, page, certificate, "Signature");
            signature.Certificate = certificate;

            // Encrypted, password protected PDF
            loadedDocument.Security.KeySize = PdfEncryptionKeySize.Key256Bit;
            loadedDocument.Security.Algorithm = PdfEncryptionAlgorithm.AES;
            loadedDocument.Security.OwnerPassword = "syncfusion";
            loadedDocument.Security.Permissions = PdfPermissionsFlags.EditAnnotations | PdfPermissionsFlags.Print | PdfPermissionsFlags.FullQualityPrint;
                        
            MemoryStream stream = new MemoryStream();
            loadedDocument.Save(stream);
            Response.ClearContent();
            Response.Expires = 0;
            Response.Buffer = true;

            string disposition = "content-disposition";
            Response.AddHeader(disposition, "attachment; filename=Sample.pdf");
            Response.AddHeader("Content-Type", "application/pdf");
            Response.Clear();
            stream.WriteTo(Response.OutputStream);
            Response.End();

            loadedDocument.Close();

        }
        
    }
}